#include "dmn.h"

int
resolve_pkt (struct pktlog *pkt)
{

  extern int lookopt;

  struct servent *new_pt;
  struct hostent *new_hst;
  struct in_addr hst;

  FILE *extsvc;
  char buf[1024];
  char portprot[12];
  int counter;

  if (isupper (pkt->proto[0]))
    {
      for (counter = 0; pkt->proto[counter] != '\0'; counter++)
	pkt->proto[counter] = tolower (pkt->proto[counter]);
    }

  if (strcmp (pkt->proto, "tcp") == 0 || strcmp (pkt->proto, "udp") == 0)
    {
      pkt->icmptype = pkt->icmpcode = 0;
      strcpy (pkt->icmp_res, "");
      if (lookopt == USE_EXT_SVC)
	{
	  if ((extsvc = fopen (SVCFILE, "r")) != NULL)
	    {
	      sprintf (portprot, "%d", pkt->dstpt);
	      strcat (portprot, "/");
	      strcat (portprot, pkt->proto);
	      while (fgets (buf, sizeof (buf), extsvc) != NULL)
		{
		  if (buf[0] == '#')
		    continue;
		  if (strstr (buf, portprot) != NULL)
		    {
		      sscanf (buf, "%15s", pkt->dstpt_res);
		      break;
		    }
		}
	      fclose (extsvc);
	    }
	  else
	    lookopt = USE_STD_SVC;
	}
      else
	{
	  if ((new_pt = getservbyport (htons (pkt->dstpt), pkt->proto)) !=
	      NULL)
	    strncpy (pkt->dstpt_res, new_pt->s_name, 16);
	  pkt->dstpt_res[15] = 0;
	}
    }
  else if (strcmp (pkt->proto, "icmp") == 0)
    {
      icmp_resolve (pkt->icmptype, pkt->icmpcode, pkt->icmp_res);
      pkt->dstpt = pkt->srcpt = 0;
      strcpy (pkt->dstpt_res, "");
    }
  else
    return 0;

  for (counter = 0; pkt->proto[counter] != '\0'; counter++)
    pkt->proto[counter] = toupper (pkt->proto[counter]);
  inet_aton (pkt->srcip, &hst);

  if ((new_hst = gethostbyaddr ((char *) &hst, sizeof (hst), AF_INET))
      != NULL)
    strncpy (pkt->srcip_res, new_hst->h_name, 255);
  pkt->srcip_res[254] = 0;

  return (1);
}
